Package Scientific :: Package Signals :: Module Models :: Class AutoRegressiveModel

[frames] | no frames]

# Class AutoRegressiveModel

Known Subclasses:
  - AveragedAutoRegressiveModel

Auto-regressive model for stochastic process

This implementation uses the Burg algorithm to obtain the coefficients of the AR model.

Instance Methods

__init__(self, order, data, delta_t=1) |

Scientific.Functions.Interpolation.InterpolatingFunction

correlation(self, nsteps) Returns: the autocorrelation function of the process as estimated from the AR model |

frictionConstant(self) Returns: the friction constant of the process, i.e. |

Scientific.Functions.Interpolation.InterpolatingFunction

memoryFunction(self, nsteps) Returns: the memory function of the process as estimated from the AR model |

Scientific.Function.Rational.RationalFunction

memoryFunctionZ(self) Returns: the z-transform of the process' memory function |

Scientific.Function.Rational.RationalFunction

memoryFunctionZapprox(self, den_order) Returns: an approximation to the z-transform of the process' memory function that correponds to an expansion of the denominator up to order den_order |

`Numeric.array` of `complex`

poles(self) Returns: the poles of the model in the complex z-plane |

`float` or `complex`

predictStep(self) Calculates the linear prediction of the next step in the series. |

`Numeric.array` of `float`

spectrum(self, omega) Returns: the frequency spectrum of the process |

Method Details

### __init__(self, order, data, delta_t=1)
(Constructor)

Parameters:
  - `order` (`int`) - the order of the model
  - `data` (sequence of `float` or `complex`) - the time series
  - `delta_t` (`float`) - the sampling interval for the time series

### correlation(self, nsteps)

Parameters:
  - `nsteps` (`int`) - the number of time steps for which the autocorrelation function is to be evaluated
Returns: Scientific.Functions.Interpolation.InterpolatingFunction
  the autocorrelation function of the process as estimated from the AR model

### frictionConstant(self)

Returns:
  the friction constant of the process, i.e. the integral over the memory function

### memoryFunction(self, nsteps)

Parameters:
  - `nsteps` (`int`) - the number of time steps for which the memory function is to be evaluated
Returns: Scientific.Functions.Interpolation.InterpolatingFunction
  the memory function of the process as estimated from the AR model

### memoryFunctionZ(self)

Returns: Scientific.Function.Rational.RationalFunction
  the z-transform of the process' memory function

### memoryFunctionZapprox(self, den_order)

Parameters:
  - `den_order` (`int`)
Returns: Scientific.Function.Rational.RationalFunction
  an approximation to the z-transform of the process' memory function that correponds to an expansion of the denominator up to order den_order

### poles(self)

Returns: `Numeric.array` of `complex`
  the poles of the model in the complex z-plane

### predictStep(self)

Calculates the linear prediction of the next step in the series. This step is appended internally to the current trajectory, making it possible to call this method repeatedly in order to obtain a sequence of predicted steps.

Returns: `float` or `complex`
  the predicted step

### spectrum(self, omega)

Parameters:
  - `omega` (`Numeric.array` of `float`) - the angular frequencies at which the spectrum is to be evaluated
Returns: `Numeric.array` of `float`
  the frequency spectrum of the process